# coding: utf-8

"""
    Alfresco Content Services REST API

    **Core API**  Provides access to the core features of Alfresco Content Services.   # noqa: E501

    OpenAPI spec version: 1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from alfresco_core_api_client.configuration import Configuration


class Node(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'node_type': 'str',
        'is_folder': 'bool',
        'is_file': 'bool',
        'is_locked': 'bool',
        'modified_at': 'datetime',
        'modified_by_user': 'UserInfo',
        'created_at': 'datetime',
        'created_by_user': 'UserInfo',
        'parent_id': 'str',
        'is_link': 'bool',
        'is_favorite': 'bool',
        'is_direct_link_enabled': 'bool',
        'content': 'ContentInfo',
        'aspect_names': 'list[str]',
        'properties': 'object',
        'allowable_operations': 'list[str]',
        'path': 'PathInfo',
        'permissions': 'PermissionsInfo',
        'definition': 'Definition'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'node_type': 'nodeType',
        'is_folder': 'isFolder',
        'is_file': 'isFile',
        'is_locked': 'isLocked',
        'modified_at': 'modifiedAt',
        'modified_by_user': 'modifiedByUser',
        'created_at': 'createdAt',
        'created_by_user': 'createdByUser',
        'parent_id': 'parentId',
        'is_link': 'isLink',
        'is_favorite': 'isFavorite',
        'is_direct_link_enabled': 'isDirectLinkEnabled',
        'content': 'content',
        'aspect_names': 'aspectNames',
        'properties': 'properties',
        'allowable_operations': 'allowableOperations',
        'path': 'path',
        'permissions': 'permissions',
        'definition': 'definition'
    }

    def __init__(self, id=None, name=None, node_type=None, is_folder=None, is_file=None, is_locked=False, modified_at=None, modified_by_user=None, created_at=None, created_by_user=None, parent_id=None, is_link=None, is_favorite=None, is_direct_link_enabled=None, content=None, aspect_names=None, properties=None, allowable_operations=None, path=None, permissions=None, definition=None, _configuration=None):  # noqa: E501
        """Node - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._id = None
        self._name = None
        self._node_type = None
        self._is_folder = None
        self._is_file = None
        self._is_locked = None
        self._modified_at = None
        self._modified_by_user = None
        self._created_at = None
        self._created_by_user = None
        self._parent_id = None
        self._is_link = None
        self._is_favorite = None
        self._is_direct_link_enabled = None
        self._content = None
        self._aspect_names = None
        self._properties = None
        self._allowable_operations = None
        self._path = None
        self._permissions = None
        self._definition = None
        self.discriminator = None

        self.id = id
        self.name = name
        self.node_type = node_type
        self.is_folder = is_folder
        self.is_file = is_file
        if is_locked is not None:
            self.is_locked = is_locked
        self.modified_at = modified_at
        self.modified_by_user = modified_by_user
        self.created_at = created_at
        self.created_by_user = created_by_user
        if parent_id is not None:
            self.parent_id = parent_id
        if is_link is not None:
            self.is_link = is_link
        if is_favorite is not None:
            self.is_favorite = is_favorite
        if is_direct_link_enabled is not None:
            self.is_direct_link_enabled = is_direct_link_enabled
        if content is not None:
            self.content = content
        if aspect_names is not None:
            self.aspect_names = aspect_names
        if properties is not None:
            self.properties = properties
        if allowable_operations is not None:
            self.allowable_operations = allowable_operations
        if path is not None:
            self.path = path
        if permissions is not None:
            self.permissions = permissions
        if definition is not None:
            self.definition = definition

    @property
    def id(self):
        """Gets the id of this Node.  # noqa: E501


        :return: The id of this Node.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Node.


        :param id: The id of this Node.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this Node.  # noqa: E501

        The name must not contain spaces or the following special characters: * \" < > \\ / ? : and |. The character . must not be used at the end of the name.   # noqa: E501

        :return: The name of this Node.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Node.

        The name must not contain spaces or the following special characters: * \" < > \\ / ? : and |. The character . must not be used at the end of the name.   # noqa: E501

        :param name: The name of this Node.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                name is not None and not re.search(r'^(?!(.*[\\\"\\*\\\\\\>\\<\\?\/\\:\\|]+.*)|(.*[\\.]?.*[\\.]+$)|(.*[ ]+$))', name)):  # noqa: E501
            raise ValueError(r"Invalid value for `name`, must be a follow pattern or equal to `/^(?!(.*[\\\"\\*\\\\\\>\\<\\?\/\\:\\|]+.*)|(.*[\\.]?.*[\\.]+$)|(.*[ ]+$))/`")  # noqa: E501

        self._name = name

    @property
    def node_type(self):
        """Gets the node_type of this Node.  # noqa: E501


        :return: The node_type of this Node.  # noqa: E501
        :rtype: str
        """
        return self._node_type

    @node_type.setter
    def node_type(self, node_type):
        """Sets the node_type of this Node.


        :param node_type: The node_type of this Node.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and node_type is None:
            raise ValueError("Invalid value for `node_type`, must not be `None`")  # noqa: E501

        self._node_type = node_type

    @property
    def is_folder(self):
        """Gets the is_folder of this Node.  # noqa: E501


        :return: The is_folder of this Node.  # noqa: E501
        :rtype: bool
        """
        return self._is_folder

    @is_folder.setter
    def is_folder(self, is_folder):
        """Sets the is_folder of this Node.


        :param is_folder: The is_folder of this Node.  # noqa: E501
        :type: bool
        """
        if self._configuration.client_side_validation and is_folder is None:
            raise ValueError("Invalid value for `is_folder`, must not be `None`")  # noqa: E501

        self._is_folder = is_folder

    @property
    def is_file(self):
        """Gets the is_file of this Node.  # noqa: E501


        :return: The is_file of this Node.  # noqa: E501
        :rtype: bool
        """
        return self._is_file

    @is_file.setter
    def is_file(self, is_file):
        """Sets the is_file of this Node.


        :param is_file: The is_file of this Node.  # noqa: E501
        :type: bool
        """
        if self._configuration.client_side_validation and is_file is None:
            raise ValueError("Invalid value for `is_file`, must not be `None`")  # noqa: E501

        self._is_file = is_file

    @property
    def is_locked(self):
        """Gets the is_locked of this Node.  # noqa: E501


        :return: The is_locked of this Node.  # noqa: E501
        :rtype: bool
        """
        return self._is_locked

    @is_locked.setter
    def is_locked(self, is_locked):
        """Sets the is_locked of this Node.


        :param is_locked: The is_locked of this Node.  # noqa: E501
        :type: bool
        """

        self._is_locked = is_locked

    @property
    def modified_at(self):
        """Gets the modified_at of this Node.  # noqa: E501


        :return: The modified_at of this Node.  # noqa: E501
        :rtype: datetime
        """
        return self._modified_at

    @modified_at.setter
    def modified_at(self, modified_at):
        """Sets the modified_at of this Node.


        :param modified_at: The modified_at of this Node.  # noqa: E501
        :type: datetime
        """
        if self._configuration.client_side_validation and modified_at is None:
            raise ValueError("Invalid value for `modified_at`, must not be `None`")  # noqa: E501

        self._modified_at = modified_at

    @property
    def modified_by_user(self):
        """Gets the modified_by_user of this Node.  # noqa: E501


        :return: The modified_by_user of this Node.  # noqa: E501
        :rtype: UserInfo
        """
        return self._modified_by_user

    @modified_by_user.setter
    def modified_by_user(self, modified_by_user):
        """Sets the modified_by_user of this Node.


        :param modified_by_user: The modified_by_user of this Node.  # noqa: E501
        :type: UserInfo
        """
        if self._configuration.client_side_validation and modified_by_user is None:
            raise ValueError("Invalid value for `modified_by_user`, must not be `None`")  # noqa: E501

        self._modified_by_user = modified_by_user

    @property
    def created_at(self):
        """Gets the created_at of this Node.  # noqa: E501


        :return: The created_at of this Node.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this Node.


        :param created_at: The created_at of this Node.  # noqa: E501
        :type: datetime
        """
        if self._configuration.client_side_validation and created_at is None:
            raise ValueError("Invalid value for `created_at`, must not be `None`")  # noqa: E501

        self._created_at = created_at

    @property
    def created_by_user(self):
        """Gets the created_by_user of this Node.  # noqa: E501


        :return: The created_by_user of this Node.  # noqa: E501
        :rtype: UserInfo
        """
        return self._created_by_user

    @created_by_user.setter
    def created_by_user(self, created_by_user):
        """Sets the created_by_user of this Node.


        :param created_by_user: The created_by_user of this Node.  # noqa: E501
        :type: UserInfo
        """
        if self._configuration.client_side_validation and created_by_user is None:
            raise ValueError("Invalid value for `created_by_user`, must not be `None`")  # noqa: E501

        self._created_by_user = created_by_user

    @property
    def parent_id(self):
        """Gets the parent_id of this Node.  # noqa: E501


        :return: The parent_id of this Node.  # noqa: E501
        :rtype: str
        """
        return self._parent_id

    @parent_id.setter
    def parent_id(self, parent_id):
        """Sets the parent_id of this Node.


        :param parent_id: The parent_id of this Node.  # noqa: E501
        :type: str
        """

        self._parent_id = parent_id

    @property
    def is_link(self):
        """Gets the is_link of this Node.  # noqa: E501


        :return: The is_link of this Node.  # noqa: E501
        :rtype: bool
        """
        return self._is_link

    @is_link.setter
    def is_link(self, is_link):
        """Sets the is_link of this Node.


        :param is_link: The is_link of this Node.  # noqa: E501
        :type: bool
        """

        self._is_link = is_link

    @property
    def is_favorite(self):
        """Gets the is_favorite of this Node.  # noqa: E501


        :return: The is_favorite of this Node.  # noqa: E501
        :rtype: bool
        """
        return self._is_favorite

    @is_favorite.setter
    def is_favorite(self, is_favorite):
        """Sets the is_favorite of this Node.


        :param is_favorite: The is_favorite of this Node.  # noqa: E501
        :type: bool
        """

        self._is_favorite = is_favorite

    @property
    def is_direct_link_enabled(self):
        """Gets the is_direct_link_enabled of this Node.  # noqa: E501


        :return: The is_direct_link_enabled of this Node.  # noqa: E501
        :rtype: bool
        """
        return self._is_direct_link_enabled

    @is_direct_link_enabled.setter
    def is_direct_link_enabled(self, is_direct_link_enabled):
        """Sets the is_direct_link_enabled of this Node.


        :param is_direct_link_enabled: The is_direct_link_enabled of this Node.  # noqa: E501
        :type: bool
        """

        self._is_direct_link_enabled = is_direct_link_enabled

    @property
    def content(self):
        """Gets the content of this Node.  # noqa: E501


        :return: The content of this Node.  # noqa: E501
        :rtype: ContentInfo
        """
        return self._content

    @content.setter
    def content(self, content):
        """Sets the content of this Node.


        :param content: The content of this Node.  # noqa: E501
        :type: ContentInfo
        """

        self._content = content

    @property
    def aspect_names(self):
        """Gets the aspect_names of this Node.  # noqa: E501


        :return: The aspect_names of this Node.  # noqa: E501
        :rtype: list[str]
        """
        return self._aspect_names

    @aspect_names.setter
    def aspect_names(self, aspect_names):
        """Sets the aspect_names of this Node.


        :param aspect_names: The aspect_names of this Node.  # noqa: E501
        :type: list[str]
        """

        self._aspect_names = aspect_names

    @property
    def properties(self):
        """Gets the properties of this Node.  # noqa: E501


        :return: The properties of this Node.  # noqa: E501
        :rtype: object
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this Node.


        :param properties: The properties of this Node.  # noqa: E501
        :type: object
        """

        self._properties = properties

    @property
    def allowable_operations(self):
        """Gets the allowable_operations of this Node.  # noqa: E501


        :return: The allowable_operations of this Node.  # noqa: E501
        :rtype: list[str]
        """
        return self._allowable_operations

    @allowable_operations.setter
    def allowable_operations(self, allowable_operations):
        """Sets the allowable_operations of this Node.


        :param allowable_operations: The allowable_operations of this Node.  # noqa: E501
        :type: list[str]
        """

        self._allowable_operations = allowable_operations

    @property
    def path(self):
        """Gets the path of this Node.  # noqa: E501


        :return: The path of this Node.  # noqa: E501
        :rtype: PathInfo
        """
        return self._path

    @path.setter
    def path(self, path):
        """Sets the path of this Node.


        :param path: The path of this Node.  # noqa: E501
        :type: PathInfo
        """

        self._path = path

    @property
    def permissions(self):
        """Gets the permissions of this Node.  # noqa: E501


        :return: The permissions of this Node.  # noqa: E501
        :rtype: PermissionsInfo
        """
        return self._permissions

    @permissions.setter
    def permissions(self, permissions):
        """Sets the permissions of this Node.


        :param permissions: The permissions of this Node.  # noqa: E501
        :type: PermissionsInfo
        """

        self._permissions = permissions

    @property
    def definition(self):
        """Gets the definition of this Node.  # noqa: E501


        :return: The definition of this Node.  # noqa: E501
        :rtype: Definition
        """
        return self._definition

    @definition.setter
    def definition(self, definition):
        """Sets the definition of this Node.


        :param definition: The definition of this Node.  # noqa: E501
        :type: Definition
        """

        self._definition = definition

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Node, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Node):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Node):
            return True

        return self.to_dict() != other.to_dict()
